using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductImages;
namespace CMSMicroservice.Protobuf.Validator.ProductImages;

public class CreateNewProductImagesRequestValidator : AbstractValidator<CreateNewProductImagesRequest>
{
    public CreateNewProductImagesRequestValidator()
    {
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.ImagePath)
            .NotEmpty();
        RuleFor(model => model.ImageThumbnailPath)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewProductImagesRequest>.CreateWithOptions((CreateNewProductImagesRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
